unit    egalibp;
interface
procedure write_register(register:integer;data:byte);
procedure write_register_set(table_seg,table_offset:integer);
function read_register(register:integer):byte;
procedure write_palette(table_seg,table_offset:integer);
procedure vertical_retrace;
procedure set_more_columns(columns:integer);
procedure vertical_scroll(dy:integer);
procedure horizontal_scroll(dx:integer);
procedure smooth_scroll(dx,dy:integer);
procedure clear_screen;
procedure set_mode(mode:integer);
procedure video_bios(ax,bx,cx,dx,es,bp:integer);
function get_mode:byte;
procedure get_rows_n_cols(x_seg,x_offset,y_seg,y_offset:integer);
procedure get_cursor_size(start_seg,start_offset,stop_seg,stop_offset:integer);
function get_page_size:integer;
function get_display_type:integer;
function get_scanlines:integer;
function get_memory_size:integer;
function get_primary:integer;
function get_second_adapter:integer;
procedure set_cursor_position(row,column:integer);
procedure get_cursor_position(row_seg,row_offset,column_seg,column_offset:integer);
procedure set_cursor_size(start,stop:integer);
procedure scroll_text(up,left,down,right,count:integer);
procedure scroll_page(count:integer);
procedure write_char(chr:char;row,column:integer);
procedure write_attribute(back,fore,row,column:integer);
procedure text_blink(flag:integer);
procedure write_string(row,column,string_seg,string_offset:integer);
procedure read_char_gen(buffer_seg,buffer_offset:integer);
procedure write_char_gen(cg_seg,cg_offset,start,count:integer);
procedure split_screen(split:integer);
procedure enable_second_set;
procedure disable_second_set;
procedure set_43_lines;
function read_character(row,column:integer):byte;
function read_attribute(row,column:integer):byte;
procedure pixel_set(x,y,color:integer);
procedure pixel_packed_write(x,y,color:integer);
procedure pixel_write(x,y,color:integer);
function pixel_read(x,y:integer):byte;
procedure scanline(start,stop,scanline,color:integer);
procedure solid_box(x0,y0,x1,y1,color:integer);
procedure line(x0,y0,x1,y1,color:integer);
procedure bitblt(x_src,y_src,x_dst,y_dst,width,height,fun:integer);
procedure set_cursor(andmask,xormask,backgnd,foregnd:integer);
procedure move_cursor(x,y:integer);
procedure remove_cursor;
function screen_dump:integer;
function screen_load(name_seg,name_ofs:integer):integer;
function ticks:longint;

implementation
{$L egalibp}
procedure write_register; external;
procedure write_register_set; external;
function read_register; external;
procedure write_palette; external;
procedure vertical_retrace; external;
procedure set_more_columns; external;
procedure vertical_scroll; external;
procedure horizontal_scroll; external;
procedure smooth_scroll; external;
procedure clear_screen; external;
procedure set_mode; external;
procedure video_bios; external;
function get_mode; external;
procedure get_rows_n_cols; external;
procedure get_cursor_size; external;
function get_page_size; external;
function get_display_type; external;
function get_scanlines; external;
function get_memory_size; external;
function get_primary; external;
function get_second_adapter; external;
procedure set_cursor_position; external;
procedure get_cursor_position; external;
procedure set_cursor_size; external;
procedure scroll_text; external;
procedure scroll_page; external;
procedure write_char; external;
procedure write_attribute; external;
procedure text_blink; external;
procedure write_string; external;
procedure read_char_gen; external;
procedure write_char_gen; external;
procedure split_screen; external;
procedure enable_second_set; external;
procedure disable_second_set; external;
procedure set_43_lines; external;
function read_character; external;
function read_attribute; external;
procedure pixel_set; external;
procedure pixel_packed_write; external;
procedure pixel_write; external;
function pixel_read; external;
procedure scanline; external;
procedure solid_box; external;
procedure line; external;
procedure bitblt; external;
procedure set_cursor; external;
procedure move_cursor; external;
procedure remove_cursor; external;
function screen_dump; external;
function screen_load; external;
function ticks; external;
end.
